from kivy.uix.floatlayout import FloatLayout
from kivy.lang.builder import Builder

BEGIN, CLEAR, DISCONNECT = xrange(3)


class GUI(FloatLayout):
    def __init__(self, app):
        self.app = app
        FloatLayout.__init__(self)

        self.disconnect_label = self.ids['disconnect_label']
        self.esc_label = self.ids['esc_text']
        self.paused_widgets = (self.ids['continue_button'],
                               self.ids['exit_button'],
                               self.ids['paused_label'],
                               self.ids['controls_label'])

        self.state = 0
        self.timer = 0

        self.set_state(BEGIN)

        self.show_paused(False)

    def show_paused(self, value):
        for w in self.paused_widgets:
            w.disabled = not value
            w.opacity = int(value)

    def set_state(self, state):
        if state == BEGIN:
            self.timer = 1

        elif state == CLEAR:
            self.disconnect_label.opacity = 0

        elif state == DISCONNECT:
            self.disconnect_label.opacity = 1
            self.timer = 1

        self.state = state

    def update(self, dt):
        if self.state == DISCONNECT:
            self.timer -= dt
            if self.timer <= 0:
                self.timer = 1
            self.disconnect_label.text = 'disconnecting{}'.format('.' * int(4 - (self.timer / .25)))

        elif self.state == BEGIN:
            self.timer -= dt * .1
            if self.timer <= 0:
                self.esc_label.opacity = 0
                self.set_state(CLEAR)
            else:
                self.esc_label.opacity = self.timer
