import level


# BLENDER CONVERSION - (x, -y)


def tutorial(game_manager):
    level_path = 'levels/tutorial'
    game_manager.level = level.Level(game_manager.app, level_path)

    scene = game_manager.app.graphics.get_scene(level_path)
    game_manager.app.pathfinder.generate_nodes(scene.vertices, scene.lines)
    start_node = game_manager.app.pathfinder.get_start_node()

    game_manager.add_enemy(start_node + 6)
    game_manager.add_enemy(start_node + 1)

    game_manager.add_item('0', -35, 2, -104)

    game_manager.player.respawn(0, 0)
    # game_manager.player.respawn(-36, -76)
    game_manager.goal.position.xyz = (-36, 0, -76)


def level_1(game_manager):
    level_path = 'levels/level_1'
    game_manager.level = level.Level(game_manager.app, level_path)

    scene = game_manager.app.graphics.get_scene(level_path)
    game_manager.app.pathfinder.generate_nodes(scene.vertices, scene.lines)
    start_node = game_manager.app.pathfinder.get_start_node()

    game_manager.add_enemy(start_node + 5)
    game_manager.add_enemy(start_node + 11)
    game_manager.add_enemy(start_node + 9)
    game_manager.add_enemy(start_node + 7)

    game_manager.add_item('1', 34, 2, 25)
    game_manager.add_item('2', 60, 2, 9)

    game_manager.player.respawn(0, 0)
    game_manager.goal.position.xyz = (70, 0, -45)


def leave(game_manager):
    game_manager.level = level.Level(game_manager.app, 'levels/leave')

    game_manager.add_item('3', -23, 2, 29)

    game_manager.player.respawn(0, 0)

    game_manager.goal.position.xyz = (-36.5, 0, 15)


def office(game_manager):
    level_path = 'levels/office'
    game_manager.level = level.Level(game_manager.app, level_path)

    scene = game_manager.app.graphics.get_scene(level_path)
    game_manager.app.pathfinder.generate_nodes(scene.vertices, scene.lines)
    start_node = game_manager.app.pathfinder.get_start_node()

    game_manager.add_enemy(start_node + 0)
    game_manager.add_enemy(start_node + 20)
    game_manager.add_enemy(start_node + 27)
    game_manager.add_enemy(start_node + 1)
    game_manager.add_enemy(start_node + 15)
    game_manager.add_enemy(start_node + 17)

    game_manager.add_item('4', 67, 2, -15)
    game_manager.add_item('5', 15.5, 2, 24)

    game_manager.player.respawn(0, 0)
    game_manager.goal.position.xyz = (52.5, 0, 12)


def rooftop(game_manager):
    level_path = 'levels/rooftop'
    game_manager.level = level.Level(game_manager.app, level_path)

    scene = game_manager.app.graphics.get_scene(level_path)
    game_manager.app.pathfinder.generate_nodes(scene.vertices, scene.lines)
    start_node = game_manager.app.pathfinder.get_start_node()

    game_manager.add_enemy(start_node + 5)
    game_manager.add_enemy(start_node + 4)
    game_manager.add_enemy(start_node + 3)
    game_manager.add_enemy(start_node + 15)
    game_manager.add_enemy(start_node + 11)

    game_manager.add_item('6', 34, 2, 17)

    game_manager.player.respawn(0, 0)
    game_manager.goal.position.xyz = (-40, 0, 60)


def maze(game_manager):
    level_path = 'levels/maze'
    game_manager.level = level.Level(game_manager.app, level_path)

    scene = game_manager.app.graphics.get_scene(level_path)
    game_manager.app.pathfinder.generate_nodes(scene.vertices, scene.lines)
    start_node = game_manager.app.pathfinder.get_start_node()

    game_manager.add_enemy(start_node + 13)
    game_manager.add_enemy(start_node + 8)
    game_manager.add_enemy(start_node + 4)
    game_manager.add_enemy(start_node + 12)
    game_manager.add_enemy(start_node + 17)

    if game_manager.app.game_data.get_value('win attempts') >= 2:
        game_manager.set_god_mode(True)

    game_manager.add_item('7', -29.7416, 2, -36.85)
    game_manager.add_item('8', 36.1076, 2, -2.13)

    game_manager.player.respawn(0, 0)
    game_manager.goal.position.xyz = (24.5 * 2, 0, -27.5 * 2)


LEVELS = {'tutorial': tutorial,
          'hallway': level_1,
          'leave': leave,
          'office': office,
          'rooftop': rooftop,
          'confuzing maze': maze}
