import random

import util


class Pathfinder:
    def __init__(self):
        self.nodes = {}

    def generate_nodes(self, vertices, links):
        self.nodes = {}
        for link in links:
            for i in xrange(2):
                index = link[i]
                other = link[i - 1]
                if index in self.nodes:
                    self.nodes[index][0].add(other)
                else:
                    self.nodes[index] = [{other}, vertices[index][::2], 0]

    def get_start_node(self):
        if self.nodes:
            return min(self.nodes.keys())
        else:
            return None

    def set_search_area(self, x, z):
        for i, node in enumerate(sorted(self.nodes.iterkeys(),
                                        key=lambda k: util.sqr_distance_between(self.nodes[k][1], (x, z)),
                                        reverse=True)):
            self.nodes[node][2] = i

    def get_connection(self, index):
        best_value = -1
        best_nodes = []

        for other in self.nodes[index][0]:
            value = self.nodes[other][2]
            if value == best_value:
                best_nodes.append(other)
            elif value > best_value:
                best_value = value
                best_nodes = [other]

        node = random.choice(best_nodes)
        self.nodes[node][2] = 0

        for n in self.nodes.itervalues():
            n[2] += 1

        return node
