import bullet, enemy


class ResourceManager:
    def __init__(self, app):
        self.app = app

        self.bullet_cache = set()
        self.enemy_cache = set()

    def get_bullet(self, x, y, z, angle):
        if len(self.bullet_cache) == 0:
            b = bullet.Bullet(self.app)
        else:
            b = self.bullet_cache.pop()

        b.spawn(x, y, z, angle)
        return b

    def get_enemy(self, node):
        if len(self.enemy_cache) == 0:
            e = enemy.Enemy(self.app)
        else:
            e = self.enemy_cache.pop()

        e.spawn(node)
        return e
