
import time


class StoryManager:
    def __init__(self, app):
        self.app = app
        self.story = None

    def start_story(self, story):
        self.app.game_data.set_value('start_time', time.time())
        self.story = story
        self.load_dialogue(self.story.start_name)
        self.app.game_data.reset()

    def load_dialogue(self, dialogue_name=None):
        d = self.story.set_dialogue(dialogue_name)

        if dialogue_name is not None:
            if d is None:
                print 'dialogue "{}" does not exist'.format(dialogue_name)
                d = self.story.set_dialogue(self.story.start_name)

            if self.app.root.current != 'dialogue':
                self.app.set_screen('dialogue')

            self.app.dialogue_screen.show_dialogue(d)

    def on_response(self, response=None):
        if response is not None:
            response.do_actions()
            self.load_dialogue(response.get_link())
